using System;

class Student
{
	public class ParentsEventArgs : EventArgs
	{
		public readonly int ExamMark, MoneyQuantityNeeded;

		public ParentsEventArgs(int ExamMark, int MoneyQuantityNeeded)
		{
			this.ExamMark = ExamMark;
			this.MoneyQuantityNeeded = MoneyQuantityNeeded;
		}
	}

	public delegate void ParentsEventHandler(Object sender, ParentsEventArgs args);
	public event ParentsEventHandler ParentsEvent;

	protected virtual void OnParentEvent(ParentsEventArgs args)
	{
		if(ParentsEvent != null)
		{
			ParentsEvent(this, args);
		}
	}
	
	public void AfterExam(int ExamMark)
	{
		ParentsEventArgs args = new ParentsEventArgs(ExamMark, ExamMark*20);
		OnParentEvent(args);
	}
}

class Parent
{
	public Parent(Student student)
	{
		student.ParentsEvent += new Student.ParentsEventHandler(MarksLookup);
	}
	private void MarksLookup(Object sender, Student.ParentsEventArgs args)
	{
		Console.Write("My child passed exam for {0} and wants {1} dollars\n",
			          args.ExamMark, args.MoneyQuantityNeeded);
	}
}

class App
{
	static void Main(string[] args)
	{
		Student student = new Student();
		Parent parent = new Parent(student);

		student.AfterExam(2);
		student.AfterExam(5);
	}
}